//+------------------------------------------------------------------+
//|                                               Trommel 34+Ich.mq4 |
//|                                                           Atmats |
//|                                                       Parbaudits |
//+------------------------------------------------------------------+
#property copyright "Atmats"
#property link      "Parbaudits"

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+



extern int     Aroon_Period = 20;
extern int     TimeF = 60;
extern double Lot         = 0.03;
extern double Lot1        = 0.06;
extern int Kof=200;

extern double TrailingStop = 15;
extern int Slippage       = 2;
extern int    Magic  = 16384;
double Points;


int init ()
   {
   Points = MarketInfo (Symbol(),MODE_POINT);
//-----
   return(0);
   }
//+-------------------------------------------------------------+
//|                                          |
//+-------------------------------------------------------------+
int deinit()
   {
   return(0);
   }
   
   
   int start()
{
double Up1, Up2, Dn1, Dn2;

int cnt=0, total;
// pirmreizeja datu parbaude
// svarigi parliecinaties ka eksperts darbojas ar normalu grafiku un
// esmu pareizi uzstadijis ieksejos mainigos (Loti, StopLoss,
// TakeProfit, TrailingStop)
// musu gadijuma parbaudam tikai TakeProfit
   if(Bars<100)
     {
      Print("bars mazaks par 100");
      return(0);  
     }
   
// lai atvieglotu un paatrinatu kodu, sglabajam nepieciesmos
// indikatora datud mainigajos laika
   


 Up1 = Highest(Symbol(),"Aroon_Horn2",MODE_HIGH,Aroon_Period-1,0);
 Up2 = Highest(Symbol(),"Aroon_Horn2",MODE_HIGH,Aroon_Period-1,1);
      Dn1 = Lowest(Symbol(),"Aroon_Horn2",MODE_LOW,Aroon_Period-1,0);
   Dn2 = Lowest(Symbol(),"Aroon_Horn2",MODE_LOW,Aroon_Period-1,1);
   
   //parliecinamies kada stavokli tirdzniec terminals
//vai ir ieprieks atvertas pozicijas
       int i,total_order,my_total_order;
      total_order = OrdersTotal()-1;
      my_total_order = 0;
      for(i = total_order; i >= 0; i--) {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)
        
         
          {
               if (OrderType() == OP_BUY || OrderType() == OP_SELL)  my_total_order++;
         }
      }
  
       if (my_total_order < 1)

        {
      // no opened orders identified
      if(AccountFreeMargin()<(Kof*Lot))
        {
         Print("Tev nau naudas=",(Kof*Lot),  "Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      //vai nepiesledzamies pa biezu
      // parbaudam pirksanu
      
      if ( Up1<Dn1  && Up2>Dn2) 
      
      {
         OrderSend(Symbol(),OP_BUY,Lot,Ask,Slippage,0,0,"Krusts_Up",16384,0,Green);
         if(GetLastError()==0)Print("Order opened: ",OrderOpenPrice());
         return(0); //izejam uz 10mit sekundem
         //tas ir svarigi 
        }
      if (Up1<=80 && Up2>80 && Dn2<20)
      {
         OrderSend(Symbol(),OP_BUY,Lot1,Ask,Slippage,0,0,"Max_Up",16384,0,White);
         if(GetLastError()==0)Print("Order opened: ",OrderOpenPrice());
         return(0); //izejam uz 10mit sekundem
         //tas ir svarigi 
        }
      
        // parbaudam pardosanu
       if ( Up1>Dn1  && Up2<Dn2) 
        
        
        {
         OrderSend(Symbol(),OP_SELL,Lot,Bid,Slippage,0,0,"Krusts_Dn",16384,0,Red);
         if(GetLastError()==0)Print("Order opened: ",OrderOpenPrice());
         return(0); //izejam
         }
         
       if (Dn1<=80 && Dn2>80 && Up2<20)
       {
         OrderSend(Symbol(),OP_BUY,Lot1,Ask,Slippage,0,0,"Max_Dn",16384,0,Orange);
         if(GetLastError()==0)Print("Order opened: ",OrderOpenPrice());
         return(0); //izejam uz 10mit sekundem
         //tas ir svarigi 
        }
         
         
         return(0);
       }
        
        // atverto poziciju kontrole
   // svarigi laicigi apstaties
   total=OrdersTotal();  
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // ta ir atverta pozicija? OP_BUY vai OP_SELL 
         OrderSymbol()==Symbol())  // parbaudam simbolu
        {
         if(OrderType()==OP_BUY)   // gara pozicija
           {
            // parbaudam trailing stop
            if(TrailingStop>0)  //lieto'tajs iestatijis opcijas
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop, OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
         else // savadak si ir isa pozicija
           {
            
            // parbaudam vai nav jaliek trailingStop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Points*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
          //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if (Up1>=80 && Up2<80 && Dn2>20) OrderClose(OrderTicket(),OrderLots(),Bid,3,Yellow);
         break;
        }
      if(OrderType()==OP_SELL)
        {
        if (Dn1>=80 && Dn2<80 && Up2>20) OrderClose(OrderTicket(),OrderLots(),Ask,3,OrangeRed);
         break;
        } 
        }
     }
   return(0);
  }
// beigas.
        